
from flask import Flask, render_template, url_for, request, redirect, send_file, send_from_directory, session
from flask_login import current_user, logout_user
from flask_session import Session
from flask_socketio import SocketIO, emit
from flask_wtf import FlaskForm
from wtforms import SubmitField
from flask_wtf.file import FileField, FileAllowed, FileRequired
from wtforms.validators import InputRequired
from datetime import timedelta
import pandas as pd
import time
from werkzeug.utils import secure_filename
import sys
from google.ads.googleads.client import GoogleAdsClient
from google.ads.googleads.errors import GoogleAdsException
global last_criterion_id
last_criterion_id = -1
import createcampaign as cp
from createnegativekeywords import _importexcelfile
import os


#this is referencing this file
app = Flask(__name__)
app.config['UPLOAD_PATH'] = 'uploads'
app.config['SECRET_KEY'] = 'SillyGoose123!'
app.config['SESSION_TYPE'] = 'filesystem'
app.config['SESSION_PERMANENT'] = False 
app.config['PERMANENT_SESSION_LIFETIME'] = timedelta(minutes=30)
Session(app)
socketio = SocketIO(app)

#This is where you pass the URL string of your app

#app = Flask(__name__, instance_relative_config=True)
#default value during development
#app.secret_key = 'dev'

class DataInput(FlaskForm):
    file = FileField('Filename', validators=[FileAllowed(['xlsx','xlsb','xltx','xlsm','xltm'])])
    submit = SubmitField('Submit', id="submf")

# class GoToStart(FlaskForm):
#     submit = SubmitField('Make another campaign', id="submf")


@app.route('/', methods=['POST', 'GET'])

def create_camp():
    # session.pop('MANAGER_ACCOUNT_ID', None)
    # session.pop('CUSTOMER_ID', None)
    form = DataInput()
    if session.get("CUSTOMER_ID"):
        display = "None"
    else:
        display = "True"
    if "manager_account_id" in request.form:
        session["CUSTOMER_ID"] = request.form["customer_id"]
        session["MANAGER_ACCOUNT_ID"] = request.form["manager_account_id"]
        return redirect(url_for("create_camp", form=form, display=display))
    if form.validate_on_submit():

        #request.form returns a werkzeug.datastructures.ImmutableMultiDict
        #This functions like a dictionary of key-value pairs
        dataframe_adgroup = pd.DataFrame(columns=['AdGroupName', 'SKU'])


        file_data = form.file.data
        # file_data2 = form.file_2.data
        # Specifying directory for it to be uploaded
        asset_dir = os.path.join(os.path.dirname(app.instance_path), 'uploads')
        # Getting filename from data and converting it to a secure filename.
        filename = secure_filename(file_data.filename)
        # Save to uploads folder
        file_data.save(os.path.join(asset_dir, filename))

        listofadgroup = request.form
        prev_val = '0'
        #Arrange data in dataframe with name and sku.
        count = 0
        for key in listofadgroup:
            #The first element in the data retrieved from the form is the CSRF token so we ignore the first iteration.
            if count == 0:
                count = 1
            elif count>0:
                for value in listofadgroup.getlist(key):
                    if key == 'campaign_name':
                        campaign_name = str(value)
                        print(f'This is your campaign name: {campaign_name}')
                    elif key.startswith('adgroup'):
                        prev_val = str(value)
                        print(f"I think {value} is an adgroup")
                    elif value == 'Submit':
                        pass
                    else:
                        print(f'Adding {prev_val} as your adgroup name and {value} as its associated sku(s)')
                        toadd = pd.Series([str(prev_val), str(value)], index=dataframe_adgroup.columns)
                        dataframe_adgroup=pd.concat([dataframe_adgroup, toadd.to_frame().T], axis=0, ignore_index=True)

        current_directory = os.getcwd()
        yaml_filepath = os.path.join(current_directory, 'theyamlfile', 'updatedgoogleads.yaml')
    
        #Customer ID For Google Ads - Uncomment the one you want to use
        #MonsterShop UK Account
        if session.get("CUSTOMER_ID"):
            customer_id = session.get("CUSTOMER_ID")
            print("Default Customer ID replaced with user-defined ID.")
        else:
            customer_id = '2871965672'
        
        #Yavolo UK - Expensive Account
        #customer_id = '6453874976'
        
        #Merchant Center ID Thats linked to the Google Ads account. 
        merchant_center_account_id = 107945304
        googleads_client = GoogleAdsClient.load_from_storage(yaml_filepath, version="v14")
        if session.get("MANAGER_ACCOUNT_ID"):
            googleads_client.login_customer_id = session.get("MANAGER_ACCOUNT_ID")
            print("Default Manager Account ID replaced with user-defined ID.")
        # return render_template("create_camp.html", form=form, display=display)
        
        #if the file exists, run the program.
        keyword_import = _importexcelfile(filename)
        cp._page2(googleads_client, customer_id, merchant_center_account_id, campaign_name, dataframe_adgroup, keyword_import)


        return render_template('success.html')

    print("doing nothing")
    print(form.validate_on_submit())
        
    return render_template('create_camp.html', form=form, display=display) 

@socketio.on('disconnect')
def disconnect_user():
    # print("disconnected!")
    logout_user()
    session.pop('MANAGER_ACCOUNT_ID', None)
    session.pop('CUSTOMER_ID', None)

if __name__ == "__main__":
    app.run(debug=True)